module namespace endpoints = "http://wheelfactory.com/rest/endpoints";

import module namespace rest="http://marklogic.com/appservices/rest"
    at "/MarkLogic/appservices/utils/rest.xqy";

declare function endpoints:options() {
    <options xmlns="http://marklogic.com/appservices/rest">
            
            <request uri="^/factory/warehouse/wheel/([0-9A-Za-z\-]+)$"
            endpoint="/wheel-proxy.xqy">
                <http method="GET"/>
                <uri-param name="id">$1</uri-param>
                <uri-param name="action">get-wheel</uri-param>
            </request>
            
            <request uri="^/factory/warehouse/wheel/([0-9A-Za-z\-]+)$"
            endpoint="/wheel-proxy.xqy">
                <http method="PUT"/>
                <uri-param name="id">$1</uri-param>
                <uri-param name="action">put-wheel</uri-param>
            </request>
            
            <request uri="^/factory/warehouse/wheel$" endpoint="/wheel-proxy.xqy">
                <http method="GET"/>
                <http method="POST"/>
                <uri-param name="action">get-wheel-list</uri-param>
            </request> 
            
            <request uri="^/factory/warehouse/wheel$"
            endpoint="/wheel-proxy.xqy">
                <http method="GET"/>
                <http method="POST"/>
                <uri-param name="action">post-wheel</uri-param>
            </request> 
    </options>
};

declare function endpoints:request($module as xs:string) as element(rest:request)?
{
  (endpoints:options()/rest:request[@endpoint = $module])[1]
};