
declare namespace rest = "http://exquery.org/ns/rest/annotation/";
declare namespace http = "http://expath.org/ns/http-client";

declare
    %rest:GET
    %rest:path("/hello/{$name}")
function local:hello($name) {
    <hello>
        <dear>{$name}</dear>
        <the-time-is>{current-time()}</the-time-is>
    </hello>
};

declare
    %rest:GET
    %rest:path("/goodbye/{$name}")
function local:goodbye($name) {
    (<rest:response>
        <http:response status="404"/>
    </rest:response>,
    <goodbye>{$name}</goodbye>
    )
};

local:goodbye("unknown")